/************************************************
**** BOT                                     ****
**** Operazioni di base per i robot.         ****
**** Tutti e 3 gli algoritmi derivano da     ****
**** questa classe.                          ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#if !defined(BOT_H_INCLUDED)
#define BOT_H_INCLUDED

#include "Grafo.h"
#include "RInterface.h"
#include "zTList.h"

#define		PARENT_UNASSIGNED  -1
#define		PARENT_NULL			  0

#define		COL_WHITE			  0
#define		COL_BLUE 			  1
#define		COL_RED  			  2


class BOT  
{
public:
	BOT(RInterface *ri);
	virtual ~BOT();

	// esplora tutto il grafo a partire dal nodo corrente
	void Explore();

	// salva la mappa creata dal bot
	void SaveMap(char *fname);
	
	// funzione che sara'sovrascritta dai vari tipi di bot
	virtual void _explore() {};

protected:

	Grafo *MyMap;	// la mappa che si costruisce il robot
	RInterface *RI;// l'interfaccia del robot sull'ambiente
	
	int Iso		  [MAX_VERTICES];	// f : MyMap-->RInterface
	int IsoInversa[MAX_VERTICES]; // g : RInterface-->MyMap

	/* utilizza la funzione Iso per trasformare l'etichetta vertice
	   nella memoria del robot, in un etichetta vertice utilizzata 
      dall'interfaccia. */
	int MyMap_to_RI(int Map_v);

	/* utilizza l'inversa della funzione Iso per trasformare l'etichetta
	   vertice fornita dall'interfaccia, in un etichetta vertice utilizzata 
  	   dalla memoria del robot. */
	int RI_to_MyMap(int RI_v);

	// restituisce la posizione del robot nella sua mappa
	int getMyPos();
	
	// il bot si e' appena mosso.. controlla l'ambiente esterno raccogliendo
	// nuove informazioni.
	void JustMoved(int OldPos);

   // cerca un cammino minimo dalla posizione del robot al nodo u
   // utilizzando solo i nodi esplorati
   
   zTList<int> *FindPathTo(int u, int *color);
   
   int *getColors() {return NULL;}
   
private:

	// inserisce una nuova coppia nella funzione di isomorfismo	
	void InsertIso(int from, int to);

};

#endif // !defined(BOT_H_INCLUDED)
