/************************************************
**** DFSBOT                                  ****
**** Implementazione dell'algoritmo di       ****
**** esplorazione DFS (Depth Search First)   ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#include <stdio.h>
#include "zTStack.h"
#include "DfsBOT.h"

DfsBOT::DfsBOT(RInterface *ri):BOT(ri)
{
	// eredita da BOT
}

DfsBOT::~DfsBOT()
{
}

void DfsBOT::_explore()
{	
	zTStack<int> *Pila=new zTStack<int>;

	int *Fine=new int;
	*Fine=0;
	Pila->Insert(Fine);
	
	while(!Pila->IsEmpty())
	{
	
		while(RI->ExistUnexploredEdge())	// finche' ci sono archi inesplorati...
		{
			int OldPos=getMyPos();
			if (RI->HowManyUnexploredEdge()>1)
			{
				// un nodo libero da mettere in pila
				int *nf=new int;
				*nf=OldPos;
				Pila->Insert(nf);
			}
			RI->MoveToUnexplored();
			JustMoved(OldPos);
			printf("%d ",RI->getRobotPos());fflush(stdout);
		}

		// siamo bloccati, tornare al nodo libero visitato piu RECENTEMENTE
      int *LastFreeNode;
      do
      {
		   LastFreeNode=Pila->Read();
   		Pila->Remove();
      } while (*LastFreeNode!=0 && RI->ExistUnexploredEdgeHere(MyMap_to_RI(*LastFreeNode))==false);

		if (*LastFreeNode==0)
		{	
			printf("Fine!\n");
			continue;
		}
      
      // trovare un percorso minimo per tornare all'ultimo nodo libero
		zTList<int> *Backtrack=FindPathTo(*LastFreeNode,NULL);
		zTList<int> *l;
      
      // spostare il robot lungo il cammino
		for (l=Backtrack->First();!l->IsEnd();l=l->Next())
		{
			int *a=l->Read();
			RI->MoveToExplored(MyMap_to_RI(*a));
			printf("*%d ",RI->getRobotPos());
			fflush(stdout);
		}
		delete Backtrack;
	}
	delete Pila;
	printf("\n");
}

