/************************************************
**** GREEDYBOT                               ****
**** Implementazione dell'algoritmo di       ****
**** esplorazione greedy.                    ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#include <stdio.h>
#include "GreedyBOT.h"
#include "zTCoda.h"
#include "zTStack.h"

GreedyBOT::GreedyBOT(RInterface *ri):BOT(ri)
{
	// eredita da BOT
}

GreedyBOT::~GreedyBOT()
{
}

void GreedyBOT::_explore()
{
	Greedy(getMyPos());
}

void GreedyBOT::Greedy(int home)
{/*
	Algoritmo di esplorazione greedy. Finche' ci sono archi inesplorati,
	utilizza quelli. Poi torna al nodo piu' VICINO libero e riprendi
	l'esplorazione.
	home e' la posizione di partenza
*/
	
	int i;
	zTCoda<int> *C=new zTCoda<int>;
	// vettore booleano: dice se un nodo e' saturo
	bool *Saturo=(bool*)malloc(sizeof(bool)*MAX_VERTICES);
	
	// vettore booleano: dice se un nodo e' gia' inserito in coda
	bool *Incoda=(bool*)malloc(sizeof(bool)*MAX_VERTICES);
	
	// vettore dei padri per la ricerca del cammino
	int *Tree=(int*)malloc(sizeof(int)*MAX_VERTICES);

	// inizializza
	for (i=0;i<MAX_VERTICES;i++)
		Saturo[i]=false;

	int *r;
	printf("%d ",RI->getRobotPos());fflush(stdout);
	bool end=false;

	while (!end)
	{
		while(RI->ExistUnexploredEdge())	// finche ci sono archi inesplorati
		{
   		int OldPos=getMyPos();
			if (RI->HowManyUnexploredEdge()==1)
			{
				// con questa mossa saturiamo il nodo
				Saturo[OldPos]=true;
			}
			RI->MoveToUnexplored();
			JustMoved(OldPos);
			printf("%d ",RI->getRobotPos());fflush(stdout);
		}
		r= new int;
		*r=getMyPos();
		Saturo[*r]=true;
	
		// siamo rimasti bloccati.. cercare il nodo piu vicino libero

		for (i=1;i<=MyMap->getNumVertici();i++)
		{
			Incoda[i]=false;
			Tree[i]=0;
		}

		C->Insert(r);
		Incoda[*r]=true;
		for (i=0;i<MAX_VERTICES;i++)
			Tree[i]=*r;
		int Parent=0;
		int FreeV=0;
		// fai una vista BFS, il primo nodo libero trovato e' anche il piu' vicino
		while (!C->IsEmpty())
		{
			int *v=C->Read();
			C->Remove();
	
			if (*v<=0)
			{
				Parent=-(*v);
				delete v;
				continue;
			}

			if (FreeV) continue;	// trovato!
			Tree[*v]=Parent;
		
			if (Saturo[*v]==false)
				FreeV=*v;

			zTList<int> *Adia=MyMap->getAdiacenti(*v);
			zTList<int> *l;
	
			int *p=new int;
			*p=-(*v);
			C->Insert(p);

			for (l=Adia->First();!l->IsEnd();l=l->Next())
			{
				int *u=l->Read();
				if (Incoda[*u]==false)
				{
					C->Insert(u);
					Incoda[*u]=true;
				}
			}
		}
		delete r;

		if (FreeV==0)
		{
			printf("Fine!\n");
			FreeV=home;
			break;
		}

		// trovato il nodo libero, muoverci li'

		printf("Torna a %d\n",MyMap_to_RI(FreeV));
		zTStack<int> *Pila= new zTStack<int>(true);
		int u=FreeV;
			
		while(Tree[u] != 0)
		{
			int *n =new int;
			*n=u;
			Pila->Insert(n);
			u=Tree[u];
		}
		
		// muovere il robot
		while (!Pila->IsEmpty())
		{
			int *a=Pila->Read();
		
			int OldPos=getMyPos();
			RI->MoveToExplored(MyMap_to_RI(*a));
			JustMoved(OldPos);
			printf("%d ",RI->getRobotPos());fflush(stdout);
			Pila->Remove();
		}
		delete Pila;
	}

	free (Saturo);
	free (Incoda);
	free (Tree);
}