/************************************************
**** MENU                                    ****
**** Gestisce e semplifica la creazione di   ****
**** menu con scelte numerate.               ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "Menu.h"

Menu::Menu()
{
	NumOpt=0;
}

Menu::~Menu()
{
	// libera la memoria
	for (int i=1;i<=NumOpt;i++)
	{
		free(Opzioni[i]);
	}
}

void Menu::AddOpt(char *txt)
{
	// prepara una copia dell'opzione
	char *nt=(char*)malloc(sizeof(char)*(strlen(txt)+1));
	strcpy(nt,txt);
	NumOpt++;
	Opzioni[NumOpt]=nt;	
}

int Menu::Select()
{
	if (NumOpt==0) return 0;	//errore
	int i;
	int scelta=0;
	char Buf[8];
	// stampa le opzioni
	for(i=1;i<=NumOpt;i++)
		printf(" %d. %s\n",i,Opzioni[i]);
		
	printf("\nScegli: ");
	do
	{	
		fgets(Buf,7,stdin);
		scelta=atoi(Buf);
		if (scelta<1 || scelta>NumOpt)
			scelta=0;		// scelta non valida
	} while (!scelta);
	printf("\n");
	return scelta;
}
