/************************************************
**** PANAITEBOT                              ****
**** Robot che implementa l'algoritmo di     ****
**** esplorazione di Panaite e Pelc.         ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#if !defined(PANAITEBOT_H_INCLUDED)
#define PANAITEBOT_H_INCLUDED

#include "BOT.h"

class PanaiteBOT : public BOT
{
public:
	PanaiteBOT(RInterface *ri, bool avanzato);
	virtual ~PanaiteBOT();

	void _explore();			// esplora e mappa l'ambiente

   int *getColors() {return Color;}

private:

	void Saturate(int v, bool Almost);	// satura un nodo
   
	bool IsSaturated();		// il nodo e' saturo?
   bool IsAlmostSaturated();		// il nodo e' quasi saturo?

   // trova un nodo adiacente a v non nello spanning tree
   int FindUnassigned(int v);
   
	// vettore dei padri per lo spanning tree
	int Parent[MAX_VERTICES];
	
	// colore dei nodi
	int Color [MAX_VERTICES];
    
	int InternalPenalty;			// penalita' effettuate dalla saturate
	int ExternalPenalty;			// penalita' effettuate dalla explore
   
   bool Avanzato;             // Se vero non satura completamente i nodi
};

#endif // !defined(PANAITEBOT_H_INCLUDED)
