/************************************************
**** PROGRESSBAR                             ****
**** Stampa una barra d'avanzamento.         ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
**** Larcheri Paolo       52 SI              ****
************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "ProgressBar.h"

#define  CLEARCMD    "clear"       // comando per cancellare lo schermo

ProgressBar::ProgressBar(char *title, int npassi,int prefresh,int lenbar, char step)
{/*
   npassi   --> Il numero totale di passi da effettuare
   lenbar   --> Lunghezza a video desiderata
   prefresh --> Dopo quanti passi calcolare la perc
   step     --> carattere di riempimento (es * o =)
*/
   
   // controllo il numero minimo di passi
   if (npassi<=0) npassi=1;
   
   // controllo lunghezza minima della barra
   if (lenbar<=1) lenbar=2;

   // controllo il numero di passi/refresh
   if (prefresh<=1) prefresh=1;
   if (prefresh>npassi) prefresh=npassi;


   // inizializzazione attributi
   Title=title;
   NPassi=npassi;
   PRefresh=prefresh;
   LenBar=lenbar;
   Step=step;
   CountStep=0;
   RefreshCounter=0;
   prevperc=-1;
}

ProgressBar::~ProgressBar()
{
}

void ProgressBar::Advance()
{/*
   Avanza di un passo, calcola la percentuale e se diversa da quella precedente
   stampa la barra d'avanzamento
*/
   // aggiungi i passi
   CountStep++;
   RefreshCounter++;

   // controllo di non superare il numero di passi massimo
   if (CountStep>NPassi) 
      CountStep=NPassi;
   
   if (RefreshCounter<PRefresh &&     // se non e' ora del refresh
       CountStep<NPassi)
      return;                         // esci
      
   RefreshCounter=0;
   
   
   // calcolo la percentuale attuale
	int perc=(CountStep*100)/NPassi;
   
	if (perc!=prevperc)  // se e' diversa dalla precedente
	{
      system(CLEARCMD);  // pulisci lo schermo e metti il cursore all'inizio
   	prevperc=perc;
      // STAMPA TITOLO!
      printf("%s\n",Title);
      // STAMPA DELLA BARRA!
		int a;
		printf("[");
		for (a=1;a<=perc/2;a++)
         printf("%c",Step);
		for (a=perc/2;a<50;a++)
			printf(" ");
		printf("]");
      
      // STAMPA LA PERCENTUALE!
		printf(" %d%%\n",perc);
      fflush(stdout);
   }   
}
