/************************************************
**** VERTICE                                 ****
**** Nodo di un grafo. Contiene l'insieme    ****
**** d'adiacenza.                            ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/


#if !defined(VERTICE_H_INCLUDED)
#define VERTICE_H_INCLUDED

#include "zTList.h"

class Vertice  
{
public:
	Vertice(int ID);
	virtual ~Vertice();

	// restituisce l'insieme d'adiacenza
	zTList<int> *getAdiacenti() {return Adiacenti;}

	// aggiunge un nuovo vertice adiacente
	bool AddAdiacente(int id);
	
	// verifica se un vertice e' adiacente
	bool IsAdiacente(int id);

private:
	int id;						// id di questo vertice
	zTList<int> *Adiacenti;	// lista dei vertici adiacenti
};

#endif // !defined(VERTICE_H_INCLUDED)
