/************************************************
**** ZTLIST                                  ****
**** Lista con template.                     ****
****                                         ****
**** Alessandro Santuari   6 SI              ****
************************************************/

#if !defined(ZTLIST_H_INCLUDED)
#define ZTLIST_H_INCLUDED

#include <stdlib.h>

template <class T>
class zTList  
{
public:
	zTList()					// COSTRUTTORE 1
	{
		next=prev=sentinel=this;
		elemento=NULL;
		autodelete=false;
	}
	zTList(bool AutoDelete) 	// COSTRUTTORE 2
	{
		next=prev=sentinel=this;
		elemento=NULL;
		autodelete=AutoDelete;
	}

	~zTList()				// DISTRUTTORE
	{
		if (sentinel->autodelete && elemento!=NULL)
		{
			delete [] elemento;
			elemento=NULL;
		}
		if (this==sentinel)
		{
			//eliminare tutto
			while(!IsEmpty())
				Next()->Remove();
		}
	}

	zTList *Sentinel()		// Sentinella
	{return sentinel;}

	zTList *First()			// Primo lista
	{return sentinel->next;}

	zTList *Last()			// Ultimo lista
	{return sentinel->prev;}

	zTList *Next()			// Prossimo
	{return next;}

	zTList *Prev()			// Precedente
	{return prev;}

	void Insert(T *elem)	// Inserisci nuovo
	{
		zTList<T> *temp=new zTList<T>(false);
		temp->prev=prev;
		temp->next=this;
		prev->next=temp;
		prev=temp;
		temp->Write(elem);
		temp->sentinel=sentinel;
	}

	void Remove()			// Elimina corrente (se si  sulla sentinella
	                        //                   elimina tutta la lista)
	{
		if (sentinel!=this)
		{
			prev->next=next;
			next->prev=prev;
			delete this;
		}
		else
		{
			while(IsEmpty()==false)
				next->Remove();
			delete this;
		}
	}


	T *Read()				// Leggi
	{return (elemento);}

	void Write(T *elem)		// Scrivi
	{
		if (elemento==NULL)	//totalmente nuovo
			elemento=elem;
		else if (elemento!=elem)	//sostituire l'elemento
		{
			delete elemento;
			elemento=elem;
		}
	}

	void MakeFirst()
	{
		zTList<T> *first=First();

		T *felem=first->Read();
		first->elemento=elemento;
		elemento=felem;
	}
	void MakePrev()
	{
		zTList<T> *prev=Prev();
		if (prev==sentinel) return;

		T *pelem=prev->Read();
		prev->elemento=elemento;
		elemento=pelem;
	}

	bool IsEmpty()			// Lista vuota?
	{
		return (next==this && prev==this);
	}

	bool IsEnd()			// Fine lista?
	{
		return (this==sentinel);
	}


private:

	zTList *sentinel, *prev, *next;
	T *elemento;

	bool autodelete;
};

#endif // !defined(ZTLIST_H_INCLUDED)


	

